%define maven_profile ${MavenProfile}
%define maven_settings -s mirror-settings.xml
%define backend_version 1.11.0
%define maven_repository -Dmaven.repo.local=/tmp/m2-repository

Summary: StoRM BackEnd Plugin for GridHTTPs integration
Name: storm-gridhttps-plugin
Version: 1.1.0
Release: 4%{?dist}
License: Apache License 2.0
Vendor: EMI
URL: http://storm.forge.cnaf.infn.it
Group: Application/File
Packager: Michele Dibenedetto storm-support@lists.infn.it
BuildArch: noarch
BuildRequires: maven
BuildRequires: java-devel 
Requires: storm-backend-server
Requires: java-devel
BuildRoot: %{_builddir}/%{name}-root
AutoReqProv: yes
Source: storm-gridhttps-plugin-1.1.0.tar.gz

%description
StoRM BackEnd Plugin for GridHTTPs integration

%prep


%setup -q

%build      
mvn %{maven_settings} %{maven_repository} install:install-file -DgroupId=emi.storm -DartifactId=storm-backend-server -Dversion=%{backend_version} -Dpackaging=jar -Dfile=storm-backend-server.jar
mvn %{maven_settings} %{maven_repository} -U -Dmaven.test.skip=true -Drelease=%{release} install

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT
test -d target/storm-gridhttps-plugin-fakeroot.dir && cp -vR target/storm-gridhttps-plugin-fakeroot.dir/* $RPM_BUILD_ROOT


%clean
#rm -rf $RPM_BUILD_ROOT

%post
if [ "$1" = "1" -o "$1" = "2" ] ; then
	echo "The StoRM GridHTTPS plugin is installed but NOT configured yet. You need to use yaim to configure the plugin."
	if [ ! -s /usr/share/java/storm-backend-server/storm-gridhttps-plugin.jar ] ; then 
		echo 'Creating links to StoRM GridHTTPS plugin jars in StoRM BackEnd lib folder'
		ln -sf /usr/share/java/storm-gridhttps-plugin/storm-gridhttps-plugin.jar /usr/share/java/storm-backend-server/
	fi
	if [ ! -s /usr/share/java/storm-backend-server/httpclient.jar ] ; then
		ln -sf /usr/share/java/storm-gridhttps-plugin/httpclient-*.jar /usr/share/java/storm-backend-server/httpclient.jar
	fi
	if [ ! -s /usr/share/java/storm-backend-server/httpcore.jar ] ; then
		ln -sf /usr/share/java/storm-gridhttps-plugin/httpcore-*.jar /usr/share/java/storm-backend-server/httpcore.jar
	fi
fi

%preun
if [ "$1" = "0" ] ; then
	if [ -s /usr/share/java/storm-backend-server/storm-gridhttps-plugin.jar ] ; then
		echo 'Removing old links to StoRM GridHTTPS plugin jars from StoRM BackEnd jars folder'
		unlink /usr/share/java/storm-backend-server/storm-gridhttps-plugin.jar ;
	fi
	if [ -s /usr/share/java/storm-backend-server/httpclient.jar ] ; then
		unlink /usr/share/java/storm-backend-server/httpclient.jar ;
	fi
	if [ -s /usr/share/java/storm-backend-server/httpcore.jar ] ; then
		unlink /usr/share/java/storm-backend-server/httpcore.jar ;
	fi
	
	if [ -f /etc/storm/gridhttps-plugin/storm.gridhttps.plugin.properties ] ; then
		echo 'Removing configuration file produced by YAIM'
		rm -f /etc/storm/gridhttps-plugin/storm.gridhttps.plugin.properties ;
	fi
	ls /etc/storm/gridhttps-plugin/storm.gridhttps.plugin.properties.bkp_* &> /dev/null
	if [ $? -eq 0 ]; then
		echo 'Removing configuration file backups produced by YAIM'
		rm -f /etc/storm/gridhttps-plugin/storm.gridhttps.plugin.properties.bkp_* ;
	fi
fi;

%triggerpostun -- storm-gridhttps-plugin 
if [ $1 -eq 2 ]; then
	if [ ! -s /usr/share/java/storm-backend-server/storm-gridhttps-plugin.jar ] ; then 
		echo 'Restoring links to StoRM GridHTTPS plugin jars in StoRM BackEnd lib folder'
		ln -sf /usr/share/java/storm-gridhttps-plugin/storm-gridhttps-plugin.jar /usr/share/java/storm-backend-server/
	fi
	if [ ! -s /usr/share/java/storm-backend-server/httpclient.jar ] ; then
		ln -sf /usr/share/java/storm-gridhttps-plugin/httpclient-*.jar /usr/share/java/storm-backend-server/httpclient.jar
	fi
	if [ ! -s /usr/share/java/storm-backend-server/httpcore.jar ] ; then
		ln -sf /usr/share/java/storm-gridhttps-plugin/httpcore-*.jar /usr/share/java/storm-backend-server/httpcore.jar
	fi
fi

%files
%defattr(-,root,root)
%dir /etc/storm/
%dir /etc/storm/gridhttps-plugin/
%config %attr(640,root,root) /etc/storm/gridhttps-plugin/storm.gridhttps.plugin.properties.template
%dir /usr/share/java/storm-gridhttps-plugin/
/usr/share/java/storm-gridhttps-plugin/httpcore-4.1.jar
/usr/share/java/storm-gridhttps-plugin/storm-gridhttps-plugin.jar
/usr/share/java/storm-gridhttps-plugin/httpclient-4.1.jar
%doc %dir /usr/share/doc/storm-gridhttps-plugin-%{version}/
%doc /usr/share/doc/storm-gridhttps-plugin-%{version}/CHANGELOG
%doc /usr/share/doc/storm-gridhttps-plugin-%{version}/LICENSE.txt

%changelog
* Mon Sep 26 2011 <Michele Dibenedetto> <michele.dibenedetto@cnaf.infn.it>
-changed fakeroot directory name to storm-gridhttps-plugin-fakeroot.dir

2011-09-26 11:15:26 CEST  dibenedetto
-Added assembly descriptor to provide sources for ETICS packager
-Removed tar and rpm binary files creation

2011-09-23 12:25:29 CEST  dibenedetto
-fixed a bug in preremove scriptlet, -f fails if matches more than a file

2011-09-23 12:13:22 CEST  dibenedetto
-made method moveAllPermissions of GhttpsHTTPSPluginInterface a stub, nothing has to be done
-removed empty if branches from scriptlets

2011-09-07 11:32:42 CEST  dibenedetto
-Added postRemoveTrigger and related script to restore deleted links to gridhttps-plugin jars in storm be jars folder
-Added a check o preremove scriptlet to avoid deleting links to gridhttps-plugin jars in storm be jars folder in case of rpm update

* Thu Aug 11 2011 <Michele Dibenedetto> <michele.dibenedetto@cnaf.infn.it>
- version 1.0.2-1
	
2011-06-16 10:20:48 CEST  dibenedetto
-added .noarch to the produced binary tar.gz
	
* Mon Jun 6 2011 <Michele Dibenedetto> <michele.dibenedetto@cnaf.infn.it>
- version 1.0.1-7
	
2011-06-06 18:28:32 CEST  dibenedetto
-changed configuration file searched location respecting rpm structure

2011-05-02 16:36:37 CEST  dibenedetto
-removed default property configuration file. It will be created by yaim during configuration

2011-04-06 19:31:25 CEST  dibenedetto
-enable deletion on rpm -e of configuration directory

2011-04-04 17:52:17 CEST  dibenedetto
-fixed documentation folder name (added emi- prefix)

2011-04-04 17:06:45 CEST  dibenedetto
-added emi- prefix to produced packages

2011-04-04 11:29:09 CEST  dibenedetto
-changed output directory of configuration files to /etc/storm/gridhttps-plugin

2011-03-21 12:02:23 CET  dibenedetto
-set group to Application/File
-added debug log information

2011-03-15 16:09:46 CET  dibenedetto
-Fixed post and preun scriptlets to point to correct backend installation folder. Removed jar version from the produced links

2011-03-08 19:06:24 CET  dibenedetto
-removed version from produced jar name

2011-03-08 18:25:39 CET  dibenedetto
-changed variable from build_age to age
-removed variable build_platform
-added autoreqprov

2011-03-08 13:07:19 CET  dibenedetto
-changed installation directory for configuration files to /etc/storm
-changed installation directory for documentation files, added -(version)
-marked /etc/storm as configuration directory in the produced rpm
	
2011-03-01 20:07:30 CET  dibenedetto
-fixed some bugs, moved some parameters to storm backend

2011-03-01 12:25:26 CET  dibenedetto
-renamed properties file to storm.gridhttps.plugin.properties.template
-removed configuration field on gridhttps server host and port

2011-02-25 13:26:30 CET  dibenedetto
-changed storm backend artifact group and name to mathch ETICS name

2011-02-25 12:12:27 CET  dibenedetto
-added in pom.xml infos about conflicting version of dependency respect to EMI and sl5/EPEL ones
	
2011-02-24 18:50:06 CET  dibenedetto
-added default values to the properties file
-changed installation path of path gridhttps.plugin.properties to /etc
-added post scriptlet to create simlink to the jars packaged in the rpm
-added preun scriptlet to remove simlink created by postinstall script
-added build_age and build_platform variables to the pom to be passes from mvn call to produce correct rpm and tar.gz file names
-added spec related informations to the pom
-annotated with comments the version of the required jars at build or runtime available in sl5 repository but not compliant with current implementation
-added variables to the pom to set pom directories

2011-02-20 18:50:06 CET  dibenedetto
-first commit 
-the storm-gridhhtps-plugin is responsible of make available storm-gridhttps-server functionalities to storm-backend-server
-this package implements the HTTPSPluginInterface Java interface provided by storm-backend-server
-its jar and dependencies has to be available to storm-backend-server classpath
-it interacts with storm-gridhttps-server using the servlet interface that it provides. Current version is compliant with storm-gridhttps-server servlet interface version 1.0.0
